/*=====================================================================*/
/*                                                                     */
/*       FILE NAME:        applied.c                                   */
/*                                                                     */
/*       PROGRAM NAME:     applied    (prog. 1.3)                      */
/*                                                                     */
/*                                                                     */
/*   Version 1.00                                                      */
/*                                                                     */
/*   (c) Satoru Ozawa and Dieter W. Heermann                           */
/*   Hitachi, Heidelberg July 1994                                     */
/*                                                                     */
/*=====================================================================*/

/***********************************************************************/
/* application of graphic functions                                    */
/***********************************************************************/

#include <stdio.h>
#include "sgl.h"                    /* include files for graphics   */ 

void  main(int argc, char *argv[])
{
  int      i;
  float    x, y, r;
  
  sgl_winsize(300,300);             /* display-size in pixels       */
  sgl_init();                       /* initialize graphics          */
  sgl_color(SGL_BLACK);             /* select color for drawings    */
  sgl_color_background(SGL_WHITE);  /* select color for background  */

  sgl_disc(0.25, 0.75, 0.1);           /* draw a black disc         */
  sgl_color(SGL_WHITE);                /* use white                 */
  sgl_disc(0.25, 0.75, 0.05);          /* draw a white disc         */

  sgl_color(SGL_BLACK);                /* use black                 */
  sgl_rectarea(0.65, 0.65, 0.2, 0.2);  /* draw a filled rectangle   */
  sgl_color(SGL_WHITE);                /* use white                 */
  sgl_rectarea(0.70, 0.70, 0.1, 0.1);  /* draw a filled rectangle   */

  sgl_color(SGL_BLACK);                /* use black                 */

  for(x=0.15; x<0.35; x+=0.01){        /* draw a cross              */
    sgl_disc(x, 0.25, 0.02);    
  }
  for(y=0.1; y<0.4; y+=0.01){
    sgl_disc(0.25, y, 0.02);
  }

  for(r=0.; r<=0.15; r+=0.02){          /* draw circles              */
    sgl_circle(0.75, 0.25, r);   
  }

  sgl_display();               /* display drawings */
  i = getchar();               /* hold picture until hit of any key */
}

