/*===========================================================================*/
/*                                                                           */
/*       FILE NAME:        r250.c                                            */
/*                                                                           */
/*       PROGRAM NAME:     r250                                              */
/*                                                                           */
/*                                                                           */
/*   Version 1.00                                                            */
/*                                                                           */
/*   (c) Satoru Ozawa and Dieter W. Heermann                                 */
/*   Hitachi, Heidelberg July 1994                                           */
/*                                                                           */
/*===========================================================================*/

# define RAND_MAX 2147483647

/*--------------------------------------------------------------------------*/
/*      Function: init_r250                                                 */
/*--------------------------------------------------------------------------*/
#ifdef  __STDC__
int init_r250(
   int seed,
   int *m_f_ptr)
#else
int init_r250(seed, m_f_ptr)
   int seed;
   int *m_f_ptr;
#endif
   {
    /*---------------------------------------------------------- */
    /*                     Declarations                          */
    /*---------------------------------------------------------- */

    int  i,tmp, dummy, one ;
    int  dummy1,dummy2;
    int  *start;

    /*---------------------------------------------------------- */
    /*                End of declares                            */
    /*---------------------------------------------------------- */

    start = m_f_ptr;
    srand(seed);
    one    = 1;

    /* ==== Warm up the usual random number generator === */

    for (i=0; i< 100; i++) {
        dummy = rand();
    }

    /* ==== Draw the 250 (251) initial bit sequences ==== */

    for (i=0 ; i<251; i++) {
        dummy1     = rand() << 16;
        dummy2     = rand();
        *m_f_ptr++ =  (dummy1 | dummy2) & RAND_MAX;
    }

    /* ==== Orthogonalize as best as we can ==== */

    m_f_ptr = start;
    for (i=0; i < 31; i++) {
        tmp      = *m_f_ptr;
        *m_f_ptr = tmp | one;
        one      = one << 1;
        m_f_ptr++;
    }

    return 0;
}

/*--------------------------------------------------------------------------*/
/*      Function: r250                                                      */
/*--------------------------------------------------------------------------*/
int r250 (n, x_ptr, m_f_ptr)
   int    n;
   float  *x_ptr;
   int   *m_f_ptr;
   {
    /*---------------------------------------------------------- */
    /*                     Declarations                          */
    /*---------------------------------------------------------- */

    register int   j, min,k,ll;
    float           *ran_ptr;
    register float  rand_max_float;
    static   int   ind = 1;

    /*---------------------------------------------------------- */
    /*                End of declares                            */
    /*---------------------------------------------------------- */

    ll      = n + 250;
    ran_ptr = x_ptr;
    j       = 1;
    rand_max_float = (float) RAND_MAX;

    do {
        ll = ll - (251 - ind);
        if ( ll < 147 )  min = ll;
        else             min = 147;
        for (k=ind; k < min+1; k++) {
            *(m_f_ptr+ k)   = *(m_f_ptr +k) ^ *(m_f_ptr +k+103);
            *ran_ptr++      = *(m_f_ptr+k) / rand_max_float;
            j++;
        }
        ind = k;
        if ( ll < 250 )   min = ll;
        else              min = 250;

        for ( k= ind; k < min +1; k++) {
            *(m_f_ptr+ k)   = *(m_f_ptr +k) ^ *(m_f_ptr +k-147);
            *ran_ptr++      = *(m_f_ptr+k) / rand_max_float;
            j++;
        }
        if ( k == 251 )   {
            k   = 1;
            ind = 1;
        }
    }  while( (ind == 1) & ( j < n));

   ind  = k;
   return 0;
}
