/* Example program "example_2.c", (C) Christian Muenkel 1994 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"sgl.h"

#define	N	20		/* number of particles			*/
#define	TIMES	100		/* number of integration time steps	*/
#define	DX	0.02		/* max. displacement of partices	*/
#define	DY	0.02		/*	i.e. velocities			*/

#ifdef  __STDC__
void    main(int argc, char *argv[])
#else
void    main(argc,argv)
        int     argc;
        char    *argv[];
#endif
{
 int	i,j;
 int	c1,c2,win1,win2;
 double	drand48();
 float	x[N],y[N],dx[N],dy[N],r,d;

 sgl_winsize(400,400);		/* set window size to 400x400		*/
 sgl_initm(2);			/* initialize graphics			*/

 win1 = 0;			/* window index starts at 0		*/
 win2 = 1;
 sgl_select_win(win1);		/* win1 at top left corner of screen	*/
 sgl_pos_win(0,0);		/* win1 at top left corner of screen	*/
 sgl_select_win(win2);		/* win2 at top left corner of screen	*/
 sgl_pos_win(410,0);		/* win2 on the right of win1		*/
 
 srand48(4711);			/* initialize random number generator	*/
 for (i = N-1; i >= 0; i--)
  { x[i] = (float) drand48();	/* initialize particle positions	*/
    y[i] = (float) drand48();
    dx[i] = (float) (2.0*drand48()-1.0) * DX;	/* and displacements	*/
    dy[i] = (float) (2.0*drand48()-1.0) * DY;
  }

 r = 0.03;			/* radius of circles, discs		*/
 d = 2.0 * r;			/* width and height of rectangles	*/

 c1 = sgl_colordef("VioletRed1");	/* color definition of color 1	*/
 c2 = sgl_colordef("SeaGreen2");	/*   color 2			*/
 sgl_color_background(sgl_colordef("RoyalBlue3")); /* and background	*/

 for (j = TIMES; j > 0; j--)	/* integrate motion of particles	*/
  { sgl_select_win(win1);		/* select first window		*/
    for (i = 0; i < N/2; i++)
     { x[i] += dx[i];			/* move particles		*/
       y[i] += dy[i];
       if (x[i] <= 0.0 || x[i] >= 1.0)	/* reflection on boundary	*/
		dx[i] = -dx[i];
       if (y[i] <= 0.0 || y[i] >= 1.0)
		dy[i] = -dy[i];
       sgl_color(c1);			/*	different colors	*/
       sgl_disc(x[i],y[i],r);		/*	and shapes		*/
       sgl_color(SGL_BLACK);		/* but each one has a black	*/
       sgl_circle(x[i],y[i],r);		/* 	boundary		*/
     }
    sgl_display();		/* don't forget to display the drawing	*/
    sgl_select_win(win2);		/* select second window		*/
    for (i = N/2; i < N; i++)
     { x[i] += dx[i];			/* move particles		*/
       y[i] += dy[i];
       if (x[i] <= 0.0 || x[i] >= 1.0)	/* reflection on boundary	*/
		dx[i] = -dx[i];
       if (y[i] <= 0.0 || y[i] >= 1.0)
		dy[i] = -dy[i];
       sgl_color(c2);
       sgl_rectarea(x[i],y[i],d,d);
       sgl_color(SGL_BLACK);
       sgl_rectangle(x[i],y[i],d,d);
     }
    sgl_display();		/* don't forget to display the drawing	*/
  }
}
