# makefile SGL
# Author: Christian Muenkel
# tested on SUN SPARC OS4.1.1, LINUX i486
#DIRL = /usr/local/X11/lib
#DIRH = /usr/local/X11/include
DIRL = /usr/lib/X11
DIRH = /usr/include/X11


CC=cc
COPT= -g
INCL= -I$(DIRH)
XLIBS=-L$(DIRL) -lX11
SGLLIBS=libsgl.a

LIBFILES = libsgl.o

all:		toda demo example_1 

libsgl.a:	$(LIBFILES)
		ar rv libsgl.a $(LIBFILES)
		ranlib libsgl.a
toda:		toda.o libsgl.a
		$(CC) $(COPT) $(INCL) -o toda toda.o $(SGLLIBS) $(XLIBS) -lm
demo:		demo.o libsgl.a
		$(CC) $(COPT) $(INCL) -o demo demo.o $(SGLLIBS) $(XLIBS) -lm
example_1:	example_1.o libsgl.a
		$(CC) $(COPT) $(INCL) -o example_1 example_1.o $(SGLLIBS) $(XLIBS) -lm
example_1.o:	example_1.c
		$(CC) $(COPT) $(INCL) -c example_1.c
example_2:	example_2.o libsgl.a
		$(CC) $(COPT) $(INCL) -o example_2 example_2.o $(SGLLIBS) $(XLIBS) -lm
example_2.o:	example_2.c
		$(CC) $(COPT) $(INCL) -c example_2.c
example_3:	example_3.o libsgl.a
		$(CC) $(COPT) $(INCL) -o example_3 example_3.o $(SGLLIBS) $(XLIBS) -lm
example_3.o:	example_3.c
		$(CC) $(COPT) $(INCL) -c example_3.c
demo.o:		demo.c
		$(CC) $(COPT) $(INCL) -c demo.c
toda.o:		toda.c
		$(CC) $(COPT) $(INCL) -c toda.c
libsgl.o:	libsgl.c
		$(CC) $(COPT) $(INCL) -c libsgl.c
clean:		
		rm -f toda demo example_?   *.a *.o *.aux *.log *.dvi out core *%
