/* Toda-potential  */

#include <stdio.h>
#include <math.h>
#include "sgl.h"

#define  c1min        0.5
#define  c1max        3.0
#define  c1dif        0.5
#define  rmin        -2.0
#define  rmax         2.0
#define  rdif         0.001
#define  radius       0.001

#ifdef	__STDC__
void  main(int argc, char *argv[])
#else
void	main(argc,argv)
	int	argc;
	char	*argv[];
#endif
{
  float   e, f, r, c1, c2;
  int     i;
#ifdef	__STDC__
  double  exp(double z);
  float   F(float r, float c1, float c2);
  float   EP(float r, float c1, float c2);
#else
  double	exp();
  float		F(),EP();
#endif

  sgl_winsize(512,512);             /* display size in pixels		*/
  sgl_init();                       /* initialize graphics		*/
  sgl_color(SGL_BLACK);             /* select color for drawings   	*/
  sgl_color_background(SGL_WHITE);  /* select color for background	*/

  c2 = 1.0;

  for(c1 = c1min; c1 <= c1max; c1 += c1dif)
  {
    for(r = rmin; r <= rmax; r += rdif)
    {
      e = EP(r, c1, c2);
      f = F(r, c1, c2);

      sgl_circle(0.1*r+0.25, 0.1*e+0.2, radius);
      sgl_circle(0.1*r+0.75, 0.1*f+0.4, radius);
    }
  }
  sgl_line(0.25, 0., 0.25, 1.);
  sgl_line(0., 0.2, 0.5, 0.2);
  sgl_line(0.75, 0., 0.75, 1.);
  sgl_line(0.5, 0.4, 1., 0.4);

  sgl_display();
  i = getchar();
}



/* potential */

#ifdef	__STDC__
float   EP(float r, float c1, float c2)
#else
float   EP(r,c1,c2)
	float	r,c1,c2;
#endif
{
  float e;

  e = c1/c2*(float)exp(-c2*r) + c1*r;

  return e;
}



/* force */

#ifdef	__STDC__
float   F(float r, float c1, float c2)
#else
float   F(r,c1,c2)
	float	r,c1,c2;
#endif
{

  float f;

  f = c1*((float)exp(-c2*r) - 1.);

  return f;
}



